// addMaxHeap.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>

struct node
{
	int data;
	node* left;
	node* right;
};

void swap(int *p1, int* p2)
{
	int temp;
	temp = *p1;
	*p1 = *p2;
	*p2 = temp;
}

class MaxHeap
{
private:
	int* item;
	int heapSize;
	int capacity;
	int* leftChild;
	int* rightChild;
public:
	void Add(int key);
	int getParent(int key) { return (key-1)/2; }
};

void MaxHeap::Add(int key)
{
	if (heapSize == capacity)
	{
		std::cout << "Full capacity occupied, no insert is allowed\n";
		return;
	}

	heapSize++;
	int i = heapSize - 1;
	item[i] = key;

	while (i != 0 && item[getParent(i)] < item[i])
	{
		swap(&item[i], &item[getParent(i)]);
		i = getParent(i);
	}
}
